<template>
  <div>
    <a-form>
      <a-tabs v-model="tabName" type="card">
        <a-tab-pane
            :tab="$t('functional-analysis.add-modal.failure-add')"
            key="addFault">
          <HotTable
              ref="addFault"
              key="addFault"
              v-if="tabName === 'addFault'"
              :formData="faultData"
              :headers="headers"
              :columns="columns"
              :focusCol="focusCol"
              @formDataChange="functionDataChange"
          />
        </a-tab-pane>
      </a-tabs>
    </a-form>
    <span style="display: block">
      <a-checkbox v-model="checked">{{ $t('functional-analysis.add-modal.Whether-to-synchronize-to-the-knowledge-base') }}</a-checkbox>
    </span>
    <!-- 失效参考示例图 -->
    <span v-if="tabName === 'addFault'">
      {{ $t('functional-analysis.add-modal.reference.example') }}
      <div class="header clear">
        <a>
          <img src="@/assets/fault.png" alt="logo" class="faultLogo"/>
        </a>
      </div>
    </span>
    <div slot="footer" class="mt10 text-right">
      <a-button @click="closeModal">
        {{ $t('global-btn.cancel') }}
      </a-button>
      <a-button
          type="primary"
          class="ml10"
          @click="save()"
          :loading="saveLoading"
          v-preventReClick>
        {{ $t('global-btn.confirm') }}
      </a-button>
    </div>
  </div>
</template>
<script>

import HotTable from "@/components/HotTable";
import AddDFMEALibrary from "./components/AddDFMEALibrary";
import {checkHotTableLength} from "@/utils/validate";

export default {
  name: "AddFault",
  components: {
    HotTable,
    AddDFMEALibrary
  },
  props: {
    struTypeCode: {
      default: '',
      type: String
    },
    checkedNode: {
      type: Object
    }
  },
  data() {
    return {
      faultData: [], // 添加失效
      DFMEALibraryData: [], // 添加DFMEA库
      tabName: "addFault",
      columns: [
        {data: "name", type: "text"},
      ],
      headers: [this.$t('functional-analysis.add-modal.failure')],
      focusCol: 0,
      saveLoading: false,
      selectType: 1,
      checked: true //是否同步到知识库
    };
  },
  methods: {
    /**
     * 接受子组件handsontable数据
     */
    functionDataChange(val) {
      this.faultData = val;
    },
    /**
     * 接受子组件DFMEA库数据
     */
    DFMEALibraryDataChange(val) {
      this.DFMEALibraryData = val;
    },
    /**
     * 关闭模态框
     */
    closeModal() {
      this.$emit("closeModal");
    },
    /**
     * 刷新结构树
     */
    initTree() {
      this.$emit("initTree");
    },
    /**
     * 保存
     */
    save() {
      let _that = this;
      if (_that.tabName === 'addFault') { // 失效添加：保存
        _that.saveFault();
      } else if (_that.tabName === 'addDFMEALibrary') { // DFMEA库选择：保存
        _that.saveMFMEALibrary();
      }
    },
    /**
     * 构建：失效数据
     */
    buildFaultData() {
      return this.faultData.map((item) => {
        return {name: item.name, code: item.code}
      }).filter((item) => {
        return item.name;
      });
    },
    /**
     * 校验：失效数据
     */
    validateFaultData(faultData) {
      if (faultData && faultData.length > 0) {
        let flag = true;
        faultData.some((item, idx) => {
          if (checkHotTableLength(item.name, 1000)) {
            this.$message.warning(this.$t('global-message.warn.failure-name-length', [idx + 1]));
            flag = false
            return true;
          }
        });
        return flag;
      } else {
        this.$message.warning(this.$t('global-message.warn.please-enter-not-name-line'))
        return false;
      }
    },
    /**
     * 保存：失效
     */
    saveFault() {
      let _that = this;
      // 构建数据
      let faultData = _that.buildFaultData();
      // 校验
      if (!_that.validateFaultData(faultData)) return;
      _that.saveLoading = true; // 开启：加载中...
      _that.$api.saveFault({
        fmeaId: _that.$store.getters.rfmeaId,
        struId: _that.checkedNode.id,
        struTypeCode: _that.struTypeCode,
        mfmeaStruInputModels: faultData,
        libraryPushFlag: _that.checked
      }).then((res) => {
        if (res.flag) {
          // 添加成功，关闭弹窗，刷新右侧树
          _that.$message.success(res.message, 1);
          _that.closeModal();
          _that.initTree();
        } else {
          _that.$message.error(res.message, 1);
        }
      }).catch((error) => {
        _that.$message.error(error.response.data.message,1);
      }).finally(() => {
        _that.saveLoading = false; // 关闭：加载中...
      })
    },
    /**
     * 校验：DFAME库选择
     */
    validateDFMEALibraryData() {
      let _that = this;
      if (_that.DFMEALibraryData.length === 0) {
        _that.$message.warning(this.$t('global-message.warn.please-select-node'));
        return false;
      }
      return true;
    },
    /**
     * 保存：DFAME库选择
     */
    saveMFMEALibrary() {
      let _that = this;
      // 校验
      if (!_that.validateDFMEALibraryData()) return;
      // 构建数据
      let ids = _that.DFMEALibraryData.map((item) => {
        return item.id;
      });
      _that.saveLoading = true; // 开启：加载中...
      _that.$api.saveMFMEALibrarySelect({
        fmeaId: _that.$store.getters.rfmeaId,
        struId: _that.checkedNode.id,
        selectType: _that.selectType,
        struIds: ids.toString(),
      }).then((res) => {
        if (res.flag) {
          // 添加成功，关闭弹窗，刷新右侧树
          _that.$message.success(res.message, 1);
          _that.closeModal();
          _that.initTree();
        } else {
          _that.$message.error(res.message, 1);
        }
      }).catch((error) => {
        _that.$message.error(error.response.data.message,1);
      }).finally(() => {
        _that.saveLoading = false; // 关闭：加载中...
      })
    }
  }
};
</script>
<style lang="less">
.faultLogo{
  height: 280px;
  width: 900px;
}
</style>
